# -*- coding: utf-8 -*-
# Copyright (c) 2016, University of Kaiserslautern
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright notice,
#    this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived from
#    this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
# OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Authors: Éder F. Zulian
#

import xml.etree.ElementTree as ET


class MCConfig(object):
    """ Memory Controller Configuration Class

        The format used in memory specification XML files differs from the
        format used in memory controller configuration XML files. Each class
        uses the proper format when searching for elements.
    """
    def getValue(self, id):
        return self.xmlMCConfig.findall(id)[0].attrib['value']

    def getIntValue(self, id):
        return int(self.getValue(id))

    def __init__(self, xmlfile):
        self.xmlMCConfig = ET.parse(xmlfile)


class MemSpec(object):
    """ Memory Specification Class

        The format used in memory specification XML files differs from the
        format used in memory configuration XML files. Each class uses the
        proper format when searching for elements.
    """
    def getValue(self, id):
        return self.xmlMemSpec.findall(".//parameter[@id='{0}']".
                                       format(id))[0].attrib['value']

    def getIntValue(self, id):
        return int(self.getValue(id))

    def __init__(self, xmlfile):
        self.xmlMemSpec = ET.parse(xmlfile)
